<div class="customer-details-container d-flex">

  <ng-container [ngSwitch]="isCardValid()">
    <div *ngSwitchDefault
         class="alert alert-light mb-0 d-flex flex-column flex-grow-1 align-content-center justify-content-center">
      <div class="d-flex flex-column align-items-center justify-content-center text-secondary w-100">
        <div class="text-center h5" i18n="@@cd.customerPanel.noCard">No NFC card on reader</div>
      </div>
    </div>
    <div *ngSwitchCase="'noAccount'"
         class="alert alert-warning mb-0 d-flex flex-column flex-grow-1 align-content-center justify-content-center">
      <div class="d-flex flex-column align-items-center justify-content-center text-secondary w-100">
        <div class="text-center h5" i18n="@@cd.customerPanel.noAccount">NFC card is not associated with an account</div>
      </div>
    </div>
    <div *ngSwitchCase="'valid'" matRipple [matRippleColor]="'hsla(0, 0%, 0%, 0.4)'"
         (click)="showAccountTransactions(transactionsModal)"
         class="alert alert-success mb-0 d-flex flex-row flex-grow-1 align-content-between justify-content-center">
      <div class="d-flex flex-column align-items-start justify-content-center text-white w-50">
        <strong class="d-block h5">{{currentCard.account.username}}</strong>
        <span class="h6"><ng-container i18n="@@cd.customerPanel.balance">Balance</ng-container>: <strong
          [ngClass]="{'text-warning':currentCard.account.balance < 0}">{{currentCard.account.balance | currency}}</strong></span>
        <span class="h6" *ngIf="currentDiscount$|async as currentDiscount"><ng-container
          i18n="@@cd.customerPanel.discount">Discount</ng-container>: <strong class="text-warning">{{currentDiscount}}
          %</strong></span>
      </div>
      <div class="d-flex flex-column align-items-center justify-content-center text-white w-50">
        <fa-icon [icon]="'credit-card'" [fixedWidth]="true" [size]="'2x'"></fa-icon>
        <div class="text-center pt-1" i18n="@@cd.customerPanel.accountOkay">Account OK</div>
      </div>
    </div>

    <div *ngSwitchCase="'accountLocked'" matRipple [matRippleColor]="'hsla(0, 0%, 0%, 0.4)'"
         (click)="showAccountTransactions(transactionsModal)"
         class="alert alert-danger mb-0 d-flex flex-row flex-grow-1 align-content-between justify-content-center">
      <div class="d-flex flex-column align-items-start justify-content-center text-white w-50">
        <strong class="d-block h5">{{currentCard.account.username}}</strong>
        <span class="h6"><ng-container
          i18n="@@cd.customerPanel.balance">Balance</ng-container>: <strong>{{currentCard.account.balance | currency}}</strong></span>
      </div>
      <div class="d-flex flex-column align-items-center justify-content-center text-white w-50">
        <fa-icon [icon]="'times'" [fixedWidth]="true" [size]="'2x'"></fa-icon>
        <div class="text-center pt-1" i18n="@@cd.customerPanel.accountLocked">Account LOCKED</div>
      </div>
    </div>
  </ng-container>
</div>

<ng-template let-modal let-product="product" #transactionsModal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title"><span i18n="@@cd.customerModal.title">Transaction History</span><br>
      <small>{{currentCard?.account.username}}<br>
        <span i18n="@@cd.customerModal.balance">Balance</span>: {{currentCard?.account.balance | currency}}
        <span *ngIf="currentCard?.account.overdraft > 0"><br>
          <span
            i18n="@@cd.customerModal.overdraftFacility">Overdraft Facility</span>: {{currentCard?.account.overdraft | currency}}
        </span>
      </small></h4>
    <button type="button" class="close" aria-label="Close" (click)="modalInstance.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body" style="min-height: 60vh">
    <ul class="list-group list-group-flush">
      <li class="list-group-item"
          [ngClass]="{'list-group-item-sucess': trans.transactionType == 'ChargeTransaction'}"
          *ngFor="let trans of currentTransactions?.results">
        <div class="d-flex">
          <div class="flex-shrink-1 mt-1 pr-3">
            <fa-icon style="display: block;" class="pb-2"
                     *ngIf="trans.transactionType == 'ChargeTransaction' && trans.sum > 0"
                     [icon]="'money-bill-wave'"
                     [fixedWidth]="true"
                     [size]="'2x'"></fa-icon>
            <fa-icon style="display: block;" class="pb-2"
                     *ngIf="trans.transactionType == 'ChargeTransaction' && trans.sum < 0"
                     [icon]="'hand-holding-usd'"
                     [fixedWidth]="true"
                     [size]="'2x'"></fa-icon>
            <fa-icon style="display: block;" class="pb-2"
                     *ngIf="trans.transactionType == 'PurchaseTransaction'"
                     [icon]="'shopping-cart'"
                     [fixedWidth]="true"
                     [size]="'2x'"></fa-icon>
            <button class="btn btn-link btn-block" (click)="cancelTransaction(trans)"
                    style="padding: 0;"
                    *ngIf="!trans.cancelled && (trans.timestamp | orderIsCancelable)">
              <fa-icon class="text-danger"
                       [icon]="'window-close'"
                       [fixedWidth]="true"
                       [size]="'2x'"
              ></fa-icon>
            </button>
          </div>
          <div class="flex-grow-1">
            <div class="d-flex w-100 justify-content-between">
              <h5 class="mb-1">
                <span *ngIf="trans.transactionType == 'ChargeTransaction' && trans.sum > 0"
                      i18n="@@cd.customerModal.chargeTransaction">Charged</span>
                <span *ngIf="trans.transactionType == 'ChargeTransaction' && trans.sum < 0"
                      i18n="@@cd.customerModal.withdrawalTransaction">Cash out</span>
                <span *ngIf="trans.transactionType == 'PurchaseTransaction'"
                      i18n="@@cd.customerModal.purchaseTransaction">Purchased</span>
              </h5>
              <small [title]="trans.timestamp">
                {{trans.timestamp | timeAgo}}
              </small>
            </div>
            <ul class="list-unstyled mb-1">
              <li *ngFor="let e of trans.entriesGrouped">
                <div class="d-flex justify-content-between">
                  <div class="font-weight-bol">
                    {{e.product.name}}
                    <div class="font-weight-light"> ({{e.product.price | currency}})</div>
                  </div>

                  <div style="width: 79px" class="d-flex justify-content-between">
                    <div>{{e.amount}}x</div>
                    <div class="pr-2"
                         [ngClass]="{'text-danger':e.price > e.product.price,'text-success':e.price < e.product.price}">
                      {{e.price | currency }}
                    </div>
                  </div>
                </div>
              </li>
            </ul>
            <div class="d-flex justify-content-between mb-1">
              <div>
                {{trans.comment}}
              </div>
              <div>
                <span i18n="@@cd.customerModal.totalSum">Total</span>:&nbsp;{{trans.sum | currency}}
              </div>
            </div>
          </div>
        </div>
      </li>
    </ul>
  </div>
</ng-template>
